## starpu-contrib 1.2.0+dfsg

=== debian/changelog ===
starpu-contrib (1.2.0+dfsg-4) unstable; urgency=medium

  * control: Make libstarpu-contrib-dev depend on libsocl-contrib
    (Closes: Bug#857163)

 -- Samuel Thibault <sthibault@debian.org>  Wed, 08 Mar 2017 15:39:38 +0100

starpu-contrib (1.2.0+dfsg-3) unstable; urgency=medium

  * Run the full testsuite even if there are failures.
  * control [contrib]: Build-Depend on clang-3.8 instead of gcc-5
  * rules: Pass -ccbin clang-3.8 (Closes: Bug#835941).
  * patches/nvcc_noccbin: Avoid overriding our -ccbin option.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 22 Jan 2017 21:05:52 +0100

starpu (1.2.0+dfsg-2) unstable; urgency=medium

  * debian/rules: Also set FC to set gfortran version.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 25 Oct 2016 22:49:22 +0200

starpu (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Fix final soname version.
    - Drop the documentation that we already generate from the tarball.
    - patches/openmp-valgrind: Remove, merged upstream
    - patches/examples: backport upstream fix to properly build some examples.
    - copyright: Use BSD-uthash licence name for uthash.h, since it is a
      modified BSD licence (Only the first item is kept, about keeping notices
      in source code redistribution)
    - copyright: Move standard licence texts to the end of the file.
    - copyright: Label the CL headers as Expat licence since that's it.
  * Downgrade opencl-headers build-dep to opencl-c-headers.
    (Closes: Bug#837911).
  * Build starpu-contrib on non-amd64 too (Closes: Bug#840559).

 -- Samuel Thibault <sthibault@debian.org>  Thu, 25 Aug 2016 13:50:02 +0200

starpu (1.2.0~rc2+dfsg-2) experimental; urgency=medium

  * Fix libsocl conflicting package names (Closes: Bug#779599).

 -- Samuel Thibault <sthibault@debian.org>  Tue, 07 Jul 2015 16:29:49 +0200

starpu (1.2.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Rename libstarpu-1.2-0 to libstarpu-1.2-1 according to soname bump.
  * Merge unstable changes (Closes: Bug#779599).

 -- Samuel Thibault <sthibault@debian.org>  Tue, 03 Mar 2015 10:40:17 +0100

starpu (1.2.0~20141210+dfsg-1) experimental; urgency=medium

  * New upstream snapshot.
    - Bump sonames to 1.2-0.
    - control: Add libleveldb-dev.
    - rules: Add --enable-openmp.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 10 Dec 2014 17:33:58 +0100

starpu (1.1.4+dfsg-6) unstable; urgency=medium

  * debian/patches/cnf: Drop testing for unused f77.h.
  * control:
    - Bump Standards-Version to 3.9.8 (no change)
    - Drop actually-unused libcnf-dev dependency.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 14 Jul 2016 12:12:16 +0200

starpu (1.1.4+dfsg-5) unstable; urgency=medium

  * Drop i386 arch from contrib, CUDA only supports amd64 nowadays.
  * watch: Update to submission from bartm.
  * rules: Use dpkg-parsechangelog.
  * control: Bump Standards-Version to 3.9.7 (no change).
  * starpu-examples.install: Add missing OpenCL programs.
  * Bump starpu-contrib gcc dependency to 5, now that CUDA 7.5 is in
    (Closes: Bug#818764).

 -- Samuel Thibault <sthibault@debian.org>  Tue, 03 May 2016 13:28:32 +0200

=== debian/control ===
Source: starpu-contrib
Priority: extra
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper (>= 9~), autotools-dev, dh-autoreconf,
	pkg-config,
	libnuma-dev [amd64 arm64 i386 ia64 mips mips64 mipsel mips64el powerpc ppc64el],
	libglpk-dev,
	mpi-default-dev,
	libgl1-mesa-dev | libgl-dev,
	libglu1-mesa-dev | libglu-dev,
	freeglut3-dev,
	libx11-dev,
	libblas-dev,
	libfftw3-dev,
	libhwloc-dev,
	libleveldb-dev,
	qt4-qmake, libqt4-dev, libqt4-opengl-dev, libqwt5-qt4-dev,
	valgrind [amd64 arm64 armhf i386 mips mips64 mipsel mips64el powerpc ppc64el s390x],
	guile-2.0,
	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
#	gcc-6, g++-6, gfortran-6, gcc-6-plugin-dev, gcc,
#	gcc-5, g++-5, gfortran-5, gcc-5-plugin-dev,
	clang-3.8,
	help2man, doxygen, doxygen-latex,
	nvidia-cuda-toolkit,
#Build-Conflicts: gcc-6, g++-6
Standards-Version: 3.9.8
Section: contrib/libs
Homepage: http://starpu.gforge.inria.fr/
Vcs-Svn: svn://scm.gforge.inria.fr/svn/starpu/debian/unstable
Vcs-Browser: https://gforge.inria.fr/scm/viewvc.php/debian/unstable/?root=starpu

Package: libstarpu-contrib-dev
Section: contrib/libdevel
Architecture: any
Depends: libstarpu-contrib-1.2-0 (= ${binary:Version}), libstarpu-contribfft-1.2-0 (= ${binary:Version}), libstarpu-contribmpi-1.2-0 (= ${binary:Version}), libsocl-contrib-1.2-0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${gccDeps}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
Conflicts: libstarpu-dev
Provides: libstarpu-dev
Description: Task scheduler for heterogeneous multicore machines - dev
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains development headers and libraries.

Package: libstarpu-contrib-1.2-0
Section: contrib/libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpu-1.2-0
Provides: libstarpu-1.2-0
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains the main StarPU library

Package: libstarpu-contribfft-1.2-0
Section: contrib/libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpufft-1.2-0
Provides: libstarpufft-1.2-0
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains a hybrid CPU+GPU FFT library.

Package: libstarpu-contribmpi-1.2-0
Section: contrib/libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libstarpumpi-1.2-0
Provides: libstarpumpi-1.2-0
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains MPI extensions for StarPU.

Package: starpu-contrib-tools
Section: contrib/utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: starpu-tools
Provides: starpu-tools
Description: Task scheduler for heterogeneous multicore machines - tools
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains StarPU tools.

#Package: starpu-contrib-top
#Section: utils
#Architecture: any
#Depends: ${shlibs:Depends}, ${misc:Depends}
#Replaces: starpu-tools (<< 1.0.5~), starpu-contrib-tools (<< 1.0.5~)
#Breaks: starpu-tools (<< 1.0.5~), starpu-contrib-tools (<< 1.0.5~)
#Description: Task scheduler for heterogeneous multicore machines - top
# StarPU is a runtime system that offers support for heterogeneous
# multicore machines. While many efforts are devoted to design efficient
# computation kernels for those architectures (e.g. to implement BLAS
# kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
# offloading such kernels (and implementing data coherency across
# the machine), but it also makes sure the kernels are executed as
# efficiently as possible.
# .
# This package contains a graphical top tool.
#
Package: starpu-contrib-examples
Section: contrib/science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: starpu-examples
Provides: starpu-examples
Description: Task scheduler for heterogeneous multicore machines - exs
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains application examples.

Package: libsocl-contrib-1.2-0
Section: contrib/libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsocl-1.2-0
Provides: libsocl-1.2-0
Description: Task scheduler for heterogeneous multicore machines
 StarPU is a runtime system that offers support for heterogeneous
 multicore machines. While many efforts are devoted to design efficient
 computation kernels for those architectures (e.g. to implement BLAS
 kernels on GPUs or on Cell's SPUs), StarPU not only takes care of
 offloading such kernels (and implementing data coherency across
 the machine), but it also makes sure the kernels are executed as
 efficiently as possible.
 .
 This package contains an OpenCL-compatible library interface to StarPU.

=== debian/rules ===
#!/usr/bin/make -f

DH_OPTIONS=-Bbuild

source=$(shell dpkg-parsechangelog -S Source)

# This is the current default version, which we may have to conflict against
DEFAULT_GCC_VERSION  := 6

# This is the version we want to build starpu against (may have to change
# according to plugin support)
GCC_VERSION          := 6

# These are the best versions that nvcc supports.
CONTRIB_GCC_VERSION  := 5
CONTRIB_CLANG_VERSION  := 3.8

ifeq ($(source),starpu)
#CC=gcc-$(GCC_VERSION)
#CXX=g++-$(GCC_VERSION)
#F77=gfortran-$(GCC_VERSION)
else
# nvcc sometimes chokes on some gcc features
#CC=gcc-$(CONTRIB_GCC_VERSION)
#CXX=g++-$(CONTRIB_GCC_VERSION)
#F77=gfortran-$(CONTRIB_GCC_VERSION)
#FC=gfortran-$(CONTRIB_GCC_VERSION)
endif
OMPI_CC=$(CC)
export CC
export CXX
export F77
export FC
export OMPI_CC
V=1
export V

export NVCCFLAGS = -ccbin clang-3.8 -Xcompiler -fPIC

%:
	dh $@ --parallel $(DH_OPTIONS) --with autoreconf

override_dh_auto_configure:
	dh_auto_configure $(DH_OPTIONS) -- --enable-opengl-render \
		--with-qwt-include-dir=/usr/include/qwt-qt4 \
		--with-qwt-lib=qwt-qt4 --enable-openmp --enable-quick-check

override_dh_auto_test:
	-HOME=$$PWD DISPLAY= DEB_BUILD_OPTIONS=$(patsubst parallel=%,,$(DEB_BUILD_OPTIONS)) dh_auto_test $(DH_OPTIONS) -k
	$(MAKE) -C build showcheck

#ifeq ($(source),starpu)
#override_dh_install:
#	dh_install usr/lib/starpu/*/gcc/*/*.so* /usr/lib/gcc/$(DEB_HOST_MULTIARCH)/$(GCC_VERSION)/plugin
#endif

override_dh_auto_clean:
	dh_auto_clean $(DH_OPTIONS) 
	rm -fr doc/doxygen/starpu.pdf
	rm -fr doc/doxygen/html
	rm -fr .starpu
	rm -f starpu-top/StarPU-Top
	rm -fr .nv

# This is required by the gcc plugin infrastructure
#GCC_DEBIAN_VERSION   := $(shell dpkg-query -f '$${Version}' -W $(CC))
#GCC_UPSTREAM_VERSION := $(firstword $(subst -, ,$(GCC_DEBIAN_VERSION)))
#override_dh_gencontrol:
#	dh_gencontrol -- -VgccDeps='$(CC) (>= $(GCC_DEBIAN_VERSION)), $(CC) (<< $(GCC_UPSTREAM_VERSION)A)'

# Switch to main rules
main:
	sed -i '1s/^starpu-contrib/starpu/' debian/changelog
	sed -i '1s/^Source: starpu-contrib/Source: starpu/' debian/control
	sed -i 's/Package: libstarpu-contrib/Package: libstarpu/' debian/control
	sed -i 's/Package: starpu-contrib/Package: starpu/' debian/control
	sed -i 's/Package: libsocl-contrib/Package: libsocl/' debian/control
	sed -i '/Depends/s/ libstarpu-contrib/ libstarpu/g' debian/control
	sed -i 's/Conflicts: libstarpu/Conflicts: libstarpu-contrib/' debian/control
	sed -i 's/Conflicts: libsocl/Conflicts: libsocl-contrib/' debian/control
	sed -i 's/Conflicts: starpu/Conflicts: starpu-contrib/' debian/control
	sed -i 's/^Provides:/#Provides:/' debian/control
	#sed -i 's/#	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,$$/	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,/' debian/control
	#sed -i 's/^	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,$$/#	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,/' debian/control
	sed -i 's/^	clang-$(CONTRIB_CLANG_VERSION),$$/#	clang-$(CONTRIB_CLANG_VERSION),/' debian/control
	sed -i 's/^	nvidia-cuda-toolkit/#	nvidia-cuda-toolkit/' debian/control
	#sed -i 's/^Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/#Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/' debian/control
	sed -i 's_^Section: contrib/_Section: _' debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i '/starpu-top/,/starpu-examples/s/^#//' debian/control

# Switch to contrib rules
contrib:
	sed -i '/starpu-top/,/^$$/s/^/#/' debian/control
	sed -i '1s/^starpu /starpu-contrib /' debian/changelog
	sed -i '1s/^Source: starpu/Source: starpu-contrib/' debian/control
	sed -i 's/Package: libstarpu/Package: libstarpu-contrib/' debian/control
	sed -i 's/Package: starpu/Package: starpu-contrib/' debian/control
	sed -i 's/Package: libsocl/Package: libsocl-contrib/' debian/control
	sed -i '/Depends/s/ libstarpu/ libstarpu-contrib/g' debian/control
	sed -i 's/Conflicts: libstarpu-contrib/Conflicts: libstarpu/' debian/control
	sed -i 's/Conflicts: libsocl-contrib/Conflicts: libsocl/' debian/control
	sed -i 's/Conflicts: starpu-contrib/Conflicts: starpu/' debian/control
	sed -i 's/^#Provides:/Provides:/' debian/control
	#sed -i 's/^	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,$$/#	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,/' debian/control
	#sed -i 's/#	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,$$/	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,/' debian/control
	sed -i 's/^#	clang-$(CONTRIB_CLANG_VERSION),$$/	clang-$(CONTRIB_CLANG_VERSION),/' debian/control
	sed -i 's/#	nvidia-cuda-toolkit/	nvidia-cuda-toolkit/' debian/control
	#sed -i 's/^#Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/' debian/control
	sed -i 's_contrib/contrib/_contrib_g' debian/control debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i 's_^Section: \([^/]*\)$$_Section: contrib/\1_' debian/control

## starpu-contrib 1.2.3%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: starpu-contrib
-Priority: extra
+Priority: optional
 Maintainer: Samuel Thibault <sthibault@debian.org>
 Build-Depends: debhelper (>= 9~), autotools-dev, dh-autoreconf,
 	pkg-config,
@@ -14,28 +14,30 @@
 	libfftw3-dev,
 	libhwloc-dev,
 	libleveldb-dev,
-	qt4-qmake, libqt4-dev, libqt4-opengl-dev, libqwt5-qt4-dev,
+#	qt4-qmake, libqt4-dev, libqt4-opengl-dev, libqwt5-qt4-dev,
+	qt5-qmake, qtbase5-dev, libqt5opengl5-dev, libqwt-dev, libqwt-headers,
 	valgrind [amd64 arm64 armhf i386 mips mips64 mipsel mips64el powerpc ppc64el s390x],
-	guile-2.0,
+#	guile-2.2,
 	opencl-c-headers, ocl-icd-opencl-dev | opencl-dev,
+	gfortran,
 #	gcc-6, g++-6, gfortran-6, gcc-6-plugin-dev, gcc,
-#	gcc-5, g++-5, gfortran-5, gcc-5-plugin-dev,
-	clang-3.8,
+	gcc-6, g++-6, gfortran-6, gcc-6-plugin-dev,
+#	clang-3.8,
 	help2man, doxygen, doxygen-latex,
-	nvidia-cuda-toolkit,
-#Build-Conflicts: gcc-6, g++-6
-Standards-Version: 3.9.8
+	nvidia-cuda-toolkit (>= 9~),
+#Build-Conflicts: gcc-7, g++-7
+Standards-Version: 4.1.1
 Section: contrib/libs
 Homepage: http://starpu.gforge.inria.fr/
-Vcs-Svn: svn://scm.gforge.inria.fr/svn/starpu/debian/unstable
-Vcs-Browser: https://gforge.inria.fr/scm/viewvc.php/debian/unstable/?root=starpu
+Vcs-Git: https://scm.gforge.inria.fr/anonscm/git/starpu-debian/starpu-debian.git
+Vcs-Browser: https://gforge.inria.fr/scm/browser.php?group_id=9532
 
 Package: libstarpu-contrib-dev
 Section: contrib/libdevel
 Architecture: any
-Depends: libstarpu-contrib-1.2-0 (= ${binary:Version}), libstarpu-contribfft-1.2-0 (= ${binary:Version}), libstarpu-contribmpi-1.2-0 (= ${binary:Version}), libsocl-contrib-1.2-0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${gccDeps}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
+Depends: libstarpu-contrib-1.2-3 (= ${binary:Version}) | libstarpu-contrib-any-1.2-3, libstarpu-contribfft-1.2-0 (= ${binary:Version}) | libstarpu-contrib-anyfft-1.2-0, libstarpu-contribmpi-1.2-2 (= ${binary:Version}) | libstarpu-contrib-anympi-1.2-2, libsocl-contrib-1.2-0 (= ${binary:Version}) | libsocl-contrib-any-1.2-0, ${shlibs:Depends}, ${misc:Depends}, ${gccDeps}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
 Conflicts: libstarpu-dev
-Provides: libstarpu-dev
+Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -46,13 +48,14 @@
  efficiently as possible.
  .
  This package contains development headers and libraries.
+ This "contrib" version is built against CUDA.
 
-Package: libstarpu-contrib-1.2-0
+Package: libstarpu-contrib-1.2-3
 Section: contrib/libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-1.2-0
-Provides: libstarpu-1.2-0
+Conflicts: libstarpu-1.2-3
+Provides: libstarpu-any-1.2-3
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -63,13 +66,14 @@
  efficiently as possible.
  .
  This package contains the main StarPU library
+ This "contrib" version is built against CUDA.
 
 Package: libstarpu-contribfft-1.2-0
 Section: contrib/libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libstarpufft-1.2-0
-Provides: libstarpufft-1.2-0
+Provides: libstarpu-anyfft-1.2-0
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -80,13 +84,14 @@
  efficiently as possible.
  .
  This package contains a hybrid CPU+GPU FFT library.
+ This "contrib" version is built against CUDA.
 
-Package: libstarpu-contribmpi-1.2-0
+Package: libstarpu-contribmpi-1.2-2
 Section: contrib/libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpumpi-1.2-0
-Provides: libstarpumpi-1.2-0
+Conflicts: libstarpumpi-1.2-2
+Provides: libstarpu-anympi-1.2-2
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -97,13 +102,14 @@
  efficiently as possible.
  .
  This package contains MPI extensions for StarPU.
+ This "contrib" version is built against CUDA.
 
 Package: starpu-contrib-tools
 Section: contrib/utils
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: starpu-tools
-Provides: starpu-tools
+Provides: starpu-any-tools
 Description: Task scheduler for heterogeneous multicore machines - tools
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -114,6 +120,7 @@
  efficiently as possible.
  .
  This package contains StarPU tools.
+ This "contrib" version is built against CUDA.
 
 #Package: starpu-contrib-top
 #Section: utils
@@ -137,7 +144,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: starpu-examples
-Provides: starpu-examples
+Provides: starpu-any-examples
 Description: Task scheduler for heterogeneous multicore machines - exs
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -148,13 +155,14 @@
  efficiently as possible.
  .
  This package contains application examples.
+ This "contrib" version is built against CUDA.
 
 Package: libsocl-contrib-1.2-0
 Section: contrib/libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libsocl-1.2-0
-Provides: libsocl-1.2-0
+Provides: libsocl-any-1.2-0
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -165,3 +173,4 @@
  efficiently as possible.
  .
  This package contains an OpenCL-compatible library interface to StarPU.
+ This "contrib" version is built against CUDA.

## starpu-contrib 1.2.3+dfsg

=== doc/tutorial/Makefile ===
# StarPU --- Runtime system for heterogeneous multicore architectures.
#
# Copyright (C) 2009-2011  Université de Bordeaux
# Copyright (C) 2010-2014  CNRS
#
# StarPU is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 2.1 of the License, or (at
# your option) any later version.
#
# StarPU is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See the GNU Lesser General Public License in COPYING.LGPL for more details.

CFLAGS          +=      $$(pkg-config --cflags starpu-1.1)
LDFLAGS         +=      $$(pkg-config --libs starpu-1.1)

HAS_CUDA	=	$(shell pkg-config --libs starpu-1.1 |grep -i cuda)
NVCC		?=	nvcc
HAS_OPENCL	=	$(shell pkg-config --libs starpu-1.1 |grep -i opencl)

%.o: %.cu
	nvcc $(CFLAGS) $< -c

TARGETS = hello_world vector_scal hello_world_plugin vector_scal_plugin vector_scal_task_insert

all: $(TARGETS)

VECTOR_SCAL_PREREQUISITES	=	vector_scal.o vector_scal_cpu.o
ifneq ($(strip $(HAS_CUDA)),)
VECTOR_SCAL_PREREQUISITES	+=	vector_scal_cuda.o
VECTOR_SCAL_COMPILER		=	$(NVCC)
else
VECTOR_SCAL_COMPILER		=	$(CC)
endif
ifneq ($(strip $(HAS_OPENCL)),)
VECTOR_SCAL_PREREQUISITES += vector_scal_opencl.o
endif

vector_scal: $(VECTOR_SCAL_PREREQUISITES)
	$(VECTOR_SCAL_COMPILER) $(LDFLAGS) $^ -o $@

VECTOR_SCAL_TASK_INSERT_PREREQUISITES		=	vector_scal_task_insert.o vector_scal_cpu.o
ifneq ($(strip $(HAS_CUDA)),)
VECTOR_SCAL_TASK_INSERT_PREREQUISITES		+=	vector_scal_cuda.o
VECTOR_SCAL_TASK_INSERT_COMPILER		=	$(NVCC)
else
VECTOR_SCAL_TASK_INSERT_COMPILER		=	$(CC)
endif
ifneq ($(strip $(HAS_OPENCL)),)
VECTOR_SCAL_TASK_INSERT_PREREQUISITES += vector_scal_opencl.o
endif

vector_scal_task_insert: $(VECTOR_SCAL_TASK_INSERT_PREREQUISITES)
	$(VECTOR_SCAL_TASK_INSERT_COMPILER) $(LDFLAGS) $^ -o $@

hello_world_plugin: hello_world_plugin.c
	$(CC) $(CFLAGS) -fplugin=`pkg-config starpu-1.1 --variable=gccplugin` $(LDFLAGS) $^ -o $@

VECTOR_SCAL_PLUGIN_PREREQUISITES	=	vector_scal_plugin.o
ifneq ($(strip $(HAS_CUDA)),)
VECTOR_SCAL_PLUGIN_PREREQUISITES	+=	vector_scal_plugin_cuda.o
VECTOR_SCAL_PLUGIN_COMPILER		=	$(NVCC)
else
VECTOR_SCAL_PLUGIN_COMPILER		=	$(CC)
endif

vector_scal_plugin.o: vector_scal_plugin.c
	$(CC) -c $(CFLAGS) -fplugin=`pkg-config starpu-1.1 --variable=gccplugin` $^ -o $@

vector_scal_plugin: $(VECTOR_SCAL_PLUGIN_PREREQUISITES)
	$(CC) -fplugin=`pkg-config starpu-1.1 --variable=gccplugin` $(LDFLAGS) $(VECTOR_SCAL_PLUGIN_PREREQUISITES) -o $@

clean:
	rm -f $(TARGETS) *.o

=== debian/changelog ===
starpu-contrib (1.2.3+dfsg-5build1) bionic; urgency=medium

  * No-change rebuild against CUDA 9.1

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 05 Mar 2018 23:26:55 +0000

starpu-contrib (1.2.3+dfsg-5) unstable; urgency=medium

  * control: Bump to CUDA 9.
  * rules: Use gcc 6 for nvcc.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 12 Jan 2018 10:25:46 +0100

starpu (1.2.3+dfsg-4) unstable; urgency=medium

  * control: Make -contrib packages provide -any virtual packages, so that
    packages in main can depend on main | -any and thus get apt avoid
    installing contrib and non-free packages unexpectedly (Closes: Bug#884309)
  * control: Deactivate guile dependency, which was only used for plugin tests
    (Closes: Bug#885230, Bug#885234)

 -- Samuel Thibault <sthibault@debian.org>  Fri, 05 Jan 2018 19:57:08 +0100

starpu (1.2.3+dfsg-3) unstable; urgency=medium

  * Apply upstream fix for macro test.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 20 Nov 2017 15:10:40 +0100

starpu (1.2.3+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 20 Nov 2017 13:12:57 +0100

starpu (1.2.3+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - rename libstarpu-1.2-2 to libstarpu-1.2-3 and libstarpumpi-1.2-1 to
    libstarpumpi-1.2-2 according to soname bumps.
    - patches/qt5: Refresh.
    - patches/doc: Remove, merged upstream.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 10 Nov 2017 18:32:51 +0100

starpu (1.2.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - rename libstarpu-1.2-0 to libstarpu-1.2-2 and libstarpumpi-1.2-0 to
    libstarpumpi-1.2-1 according to soname bumps.
    - patches/cnf: Remove, merged upstream.
    - patches/examples: Remove, merged upstream.
    - patches/nvcc_noccbin: Remove, merged upstream.
    - patches/doc: Add from upstream to ship doc source.
  * control: Bump Standards-Version to 4.1.1 (no changes).
  * control: Depend on gfortran (Closes: Bug#877028)
  * rules: Use NVCC_CC instead of setting -ccbin in NVCCFLAGS.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 30 Oct 2017 17:05:59 +0100

starpu (1.2.0+dfsg-5) unstable; urgency=medium

  * Update source repository URL to git.
  * patches/reproducibility: Fix reproducibility.
  * rules: Support DEB_BUILD_OPTIONS nodoc tag.
  * control: Migrate priority to optional.
  * control: Bump Standards-Version to 4.0.1.
  * patches/qt5: Upstream fixes for qt5.
  * control: Replace qt4 dependencies with qt5.
  * rules: Make sure qt5 gets detected (Closes: Bug#875196)
  * control: Replace qwt5 dependencies with qwt6.
  * rules: upgrade to libqwt 6.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 18 Aug 2017 19:39:36 +0200

starpu (1.2.0+dfsg-4) unstable; urgency=medium

  * control: Make libstarpu-dev depend on libsocl (Closes: Bug#857163)
  * rules: Append -contrib to that dependency for contrib package.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 08 Mar 2017 15:18:09 +0100

starpu (1.2.0+dfsg-3) unstable; urgency=medium

  * Run the full testsuite even if there are failures.
  * control [contrib]: Build-Depend on clang-3.8 instead of gcc-5
  * rules: Pass -ccbin clang-3.8 (Closes: Bug#835941).
  * patches/nvcc_noccbin: Avoid overriding our -ccbin option.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 22 Jan 2017 21:05:52 +0100

=== debian/rules ===
#!/usr/bin/make -f

DH_OPTIONS=-Bbuild

source=$(shell dpkg-parsechangelog -S Source)

# This is the current default version, which we may have to conflict against
DEFAULT_GCC_VERSION  := 7

# This is the version we want to build starpu against (may have to change
# according to plugin support)
GCC_VERSION          := 6

# These are the best versions that nvcc supports.
CONTRIB_GCC_VERSION  := 6
CONTRIB_CLANG_VERSION  := 3.8

ifeq ($(source),starpu)
#CC=gcc-$(GCC_VERSION)
#CXX=g++-$(GCC_VERSION)
#F77=gfortran-$(GCC_VERSION)
else
# nvcc sometimes chokes on some gcc features
CC=gcc-$(CONTRIB_GCC_VERSION)
CXX=g++-$(CONTRIB_GCC_VERSION)
F77=gfortran-$(CONTRIB_GCC_VERSION)
FC=gfortran-$(CONTRIB_GCC_VERSION)
endif
OMPI_CC=$(CC)
export CC
export CXX
export F77
export FC
export OMPI_CC
V=1
export V

export NVCC_CC = gcc-6
#export NVCC_CC = clang-3.8
export NVCCFLAGS = -Xcompiler -fPIC

export QT_SELECT=5

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
CONFIGURE_NODOC = --disable-build-doc
endif

#CONFIGURE_QWT = --with-qwt-include-dir=/usr/include/qwt \
#	--with-qwt-lib=qwt

%:
	dh $@ --parallel $(DH_OPTIONS) --with autoreconf

override_dh_auto_configure:
	dh_auto_configure $(DH_OPTIONS) -- --enable-opengl-render \
		$(CONFIGURE_QWT) \
		--enable-openmp --enable-quick-check \
		$(CONFIGURE_NODOC)

override_dh_auto_test:
	-HOME=$$PWD DISPLAY= DEB_BUILD_OPTIONS=$(patsubst parallel=%,,$(DEB_BUILD_OPTIONS)) dh_auto_test $(DH_OPTIONS) -k
	$(MAKE) -C build showcheck

#ifeq ($(source),starpu)
#override_dh_install:
#	dh_install usr/lib/starpu/*/gcc/*/*.so* /usr/lib/gcc/$(DEB_HOST_MULTIARCH)/$(GCC_VERSION)/plugin
#endif

override_dh_auto_clean:
	dh_auto_clean $(DH_OPTIONS) 
	rm -fr doc/doxygen/starpu.pdf
	rm -fr doc/doxygen/html
	rm -fr .starpu
	rm -f starpu-top/StarPU-Top
	rm -fr .nv

# This is required by the gcc plugin infrastructure
#GCC_DEBIAN_VERSION   := $(shell dpkg-query -f '$${Version}' -W $(CC))
#GCC_UPSTREAM_VERSION := $(firstword $(subst -, ,$(GCC_DEBIAN_VERSION)))
#override_dh_gencontrol:
#	dh_gencontrol -- -VgccDeps='$(CC) (>= $(GCC_DEBIAN_VERSION)), $(CC) (<< $(GCC_UPSTREAM_VERSION)A)'

# Switch to main rules
main:
	sed -i '1s/^starpu-contrib/starpu/' debian/changelog
	sed -i '1s/^Source: starpu-contrib/Source: starpu/' debian/control
	sed -i 's/Package: libstarpu-contrib/Package: libstarpu/' debian/control
	sed -i 's/Package: starpu-contrib/Package: starpu/' debian/control
	sed -i 's/Package: libsocl-contrib/Package: libsocl/' debian/control
	sed -i '/Depends/s/ libstarpu-contrib/ libstarpu/g' debian/control
	sed -i '/Depends/s/ libsocl-contrib/ libsocl/g' debian/control
	sed -i 's/Conflicts: libstarpu/Conflicts: libstarpu-contrib/' debian/control
	sed -i 's/Conflicts: libsocl/Conflicts: libsocl-contrib/' debian/control
	sed -i 's/Conflicts: starpu/Conflicts: starpu-contrib/' debian/control
	#sed -i 's/#	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,$$/	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,/' debian/control
	sed -i 's/^	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,$$/#	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,/' debian/control
	#sed -i 's/^	clang-$(CONTRIB_CLANG_VERSION),$$/#	clang-$(CONTRIB_CLANG_VERSION),/' debian/control
	sed -i 's/^	nvidia-cuda-toolkit/#	nvidia-cuda-toolkit/' debian/control
	#sed -i 's/^Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/#Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/' debian/control
	sed -i 's_^Section: contrib/_Section: _' debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i '/starpu-top/,/starpu-examples/s/^#//' debian/control
	sed -i 's/^ This "contrib" version/# This "contrib" version/' debian/control

# Switch to contrib rules
contrib:
	sed -i '/starpu-top/,/^$$/s/^/#/' debian/control
	sed -i '1s/^starpu /starpu-contrib /' debian/changelog
	sed -i '1s/^Source: starpu/Source: starpu-contrib/' debian/control
	sed -i 's/Package: libstarpu/Package: libstarpu-contrib/' debian/control
	sed -i 's/Package: starpu/Package: starpu-contrib/' debian/control
	sed -i 's/Package: libsocl/Package: libsocl-contrib/' debian/control
	sed -i '/Depends/s/ libstarpu/ libstarpu-contrib/g' debian/control
	sed -i '/Depends/s/ libsocl/ libsocl-contrib/g' debian/control
	sed -i 's/Conflicts: libstarpu-contrib/Conflicts: libstarpu/' debian/control
	sed -i 's/Conflicts: libsocl-contrib/Conflicts: libsocl/' debian/control
	sed -i 's/Conflicts: starpu-contrib/Conflicts: starpu/' debian/control
	#sed -i 's/^	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,$$/#	gcc-$(GCC_VERSION), g++-$(GCC_VERSION), gfortran-$(GCC_VERSION), gcc-$(GCC_VERSION)-plugin-dev, gcc,/' debian/control
	sed -i 's/#	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,$$/	gcc-$(CONTRIB_GCC_VERSION), g++-$(CONTRIB_GCC_VERSION), gfortran-$(CONTRIB_GCC_VERSION), gcc-$(CONTRIB_GCC_VERSION)-plugin-dev,/' debian/control
	#sed -i 's/^#	clang-$(CONTRIB_CLANG_VERSION),$$/	clang-$(CONTRIB_CLANG_VERSION),/' debian/control
	sed -i 's/#	nvidia-cuda-toolkit/	nvidia-cuda-toolkit/' debian/control
	#sed -i 's/^#Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/Build-Conflicts: gcc-$(DEFAULT_GCC_VERSION), g++-$(DEFAULT_GCC_VERSION)/' debian/control
	sed -i 's_contrib/contrib/_contrib_g' debian/control debian/control
	sed -i 's/contrib-contrib/contrib/g' debian/control debian/changelog
	sed -i 's_^Section: \([^/]*\)$$_Section: contrib/\1_' debian/control
	sed -i 's/^# This "contrib" version/ This "contrib" version/' debian/control

## starpu-contrib 1.2.4+dfsg

=== debian/changelog ===
starpu-contrib (1.2.4+dfsg-1build2) cosmic; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 13:32:03 +0000

starpu-contrib (1.2.4+dfsg-1build1) cosmic; urgency=medium

  * No-change rebuild for dune openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 May 2018 21:55:41 +0000

starpu-contrib (1.2.4+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - patches/gnu_source: Merged upstream
    - Rename packages according to soname bumps.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 13 Apr 2018 15:28:08 +0200

starpu (1.2.3+dfsg-5) unstable; urgency=medium

  * control: Bump to CUDA 9.
  * rules: Use gcc 6 for nvcc (Closes: #873416).

 -- Samuel Thibault <sthibault@debian.org>  Fri, 12 Jan 2018 10:25:46 +0100

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,7 @@
 Package: libstarpu-contrib-dev
 Section: contrib/libdevel
 Architecture: any
-Depends: libstarpu-contrib-1.2-3 (= ${binary:Version}) | libstarpu-contrib-any-1.2-3, libstarpu-contribfft-1.2-0 (= ${binary:Version}) | libstarpu-contrib-anyfft-1.2-0, libstarpu-contribmpi-1.2-2 (= ${binary:Version}) | libstarpu-contrib-anympi-1.2-2, libsocl-contrib-1.2-0 (= ${binary:Version}) | libsocl-contrib-any-1.2-0, ${shlibs:Depends}, ${misc:Depends}, ${gccDeps}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
+Depends: libstarpu-contrib-1.2-4 (= ${binary:Version}) | libstarpu-contrib-any-1.2-4, libstarpu-contribfft-1.2-0 (= ${binary:Version}) | libstarpu-contrib-anyfft-1.2-0, libstarpu-contribmpi-1.2-3 (= ${binary:Version}) | libstarpu-contrib-anympi-1.2-3, libsocl-contrib-1.2-0 (= ${binary:Version}) | libsocl-contrib-any-1.2-0, ${shlibs:Depends}, ${misc:Depends}, ${gccDeps}, libhwloc-dev, opencl-headers, ocl-icd-opencl-dev
 Conflicts: libstarpu-dev
 Provides: libstarpu-any-dev
 Description: Task scheduler for heterogeneous multicore machines - dev
@@ -50,12 +50,12 @@
  This package contains development headers and libraries.
  This "contrib" version is built against CUDA.
 
-Package: libstarpu-contrib-1.2-3
+Package: libstarpu-contrib-1.2-4
 Section: contrib/libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpu-1.2-3
-Provides: libstarpu-any-1.2-3
+Conflicts: libstarpu-1.2-4
+Provides: libstarpu-any-1.2-4
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
@@ -86,12 +86,12 @@
  This package contains a hybrid CPU+GPU FFT library.
  This "contrib" version is built against CUDA.
 
-Package: libstarpu-contribmpi-1.2-2
+Package: libstarpu-contribmpi-1.2-3
 Section: contrib/libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Conflicts: libstarpumpi-1.2-2
-Provides: libstarpu-anympi-1.2-2
+Conflicts: libstarpumpi-1.2-3
+Provides: libstarpu-anympi-1.2-3
 Description: Task scheduler for heterogeneous multicore machines
  StarPU is a runtime system that offers support for heterogeneous
  multicore machines. While many efforts are devoted to design efficient
